diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 7762378c3..7b29a180b 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -157,6 +157,7 @@ public class GameSettings {
 	public BooleanOption fullscreen = new BooleanOption(this, "fullscreen", false);
 	public BooleanOption borderlessFullscreen = new BooleanOption(this, "borderlessFullscreen", true);
 	public BooleanOption startInFullscreen = new BooleanOption(this, "startInFullscreen", true);
+	public BooleanOption osxFullscreenModeAPI = new BooleanOption(this, "osxFullscreenModeAPI", true);
 	public EnumOption<TooltipStyle> tooltipStyle = new EnumOption<>(this, "tooltipStyle", TooltipStyle.class);
 	public EnumOption<LightmapStyle> lightmapStyle = new EnumOption<>(this, "lightmapStyle", LightmapStyle.class, LightmapStyle.GRAY);
 	public BooleanOption customLightmap = new BooleanOption(this, "customLightmap", true);
diff --git a/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java b/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
index 9fd7be677..de85a957e 100644
--- a/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
+++ b/src/main/java/net/minecraft/client/render/window/GameWindowLWJGL2.java
@@ -6,6 +6,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.PanelCrashReport;
 import net.minecraft.core.Global;
 import net.minecraft.core.UnexpectedThrowable;
+import net.minecraft.core.enums.EnumOS;
 
 import org.lwjgl.LWJGLException;
 import org.lwjgl.opengl.Display;
@@ -34,7 +35,11 @@ public class GameWindowLWJGL2 implements GameWindow {
 		this.mc = minecraft;
 		this.fullscreenHelper = new FullscreenHelper(minecraft);
 		this.defaultDisplayMode = Display.getDisplayMode();
-
+		
+		if(Minecraft.getOs() == EnumOS.macos && minecraft.gameSettings.osxFullscreenModeAPI.value) {
+			System.setProperty("org.lwjgl.opengl.Display.enableOSXFullscreenModeAPI", "true");
+		}
+		
 		Display.setDisplayMode(new DisplayMode(GameResolution.defaultWidth, GameResolution.defaultHeight));
 		Display.setTitle("Better than Adventure! " + Global.VERSION);
       
